# How to Contribute to DeepLabCut

DeepLabCut is an actively developed package and we welcome community development and involvement. We are especially seeking people from underrepresented backgrounds in OSS to contribute their expertise and experience. Please get in touch if you want to discuss specific contributions you are interested in developing, and we can help shape a road-map.

We are happy to receive code extensions, bug fixes, documentation updates, etc.

If you want to contribute to the code, please make a [pull request](https://github.com/AlexEMG/DeepLabCut/pull/new/) that includes both a summary of and changes to:
- how you modified the code and what new functionality it has 
- the **OS it has been tested on**
- the **output of the [testscript.py](/examples/testscript.py)** and if you are editing the **3D code the [testscript_3d.py](/examples/testscript_3d.py)**.
- DOCSTRING update for your change
- a working example of how it works for users. 
- if it's a function that also can be used in downstream steps (i.e. could be plotted) we ask you (1) highlight this, and (2) idealy you provide that functionality as well. If you have any questions, please reach out: admin@deeplabcut.org 

DeepLabCut is an open-source tool and has benefited from suggestions and edits by many individuals: 
- the [authors](https://github.com/AlexEMG/DeepLabCut/blob/master/AUTHORS)
- [contributors](https://github.com/AlexEMG/DeepLabCut/graphs/contributors) 

